var bunyan = require('niu-express-bunyan-logger');
var Elasticsearch = require('bunyan-elasticsearch');

module.exports = function(opt) {
    var defaultEsConfig = {
        indexPattern: '[logstash-]YYYY.MM.DD',
        type: 'logs',
        host: 'localhost:9200'
    };
    var defaultLoggerConfig = {
        format: ":res-headers[x-real-ip] :ip :incoming :method :url :status-code :res-headers[content-length] :referer :user-agent :response-time ms",
        parseUA : false,
        excludes: ['*'],
        name: 'Myapp'
    };
    var esConfig = opt.esConfig || defaultEsConfig;
    var loggerConfig = opt.loggerConfig || defaultLoggerConfig;
    var streams = [];
    if (opt.esConfig) {
        var esStream = new Elasticsearch(esConfig);
        esStream.on('error', function (err) {
            console.log('Elasticsearch Stream Error:', err.stack);
        });
        streams.push({
            stream: esStream
        });
    } else {
        streams.push({ stream: process.stdout });
    }
    loggerConfig.streams = streams;
    return bunyan(loggerConfig);

};


